//---------------------------------------------------------------------------

#include <vcl.h>
#include <ddeml.h>
#pragma hdrstop

#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
HWND hDde;
unsigned long idInst;
AnsiString sTopic;
TPokeAction action;
PDdeQueItem p=new TDdeQueItem;
static const Word WM_DDE_ADDQUE = 0x402;
HSZ ServiceHSz,TopicHSz;
TThreadList *fDdeQue=new TThreadList;
int dataSize;
unsigned char szDDEData;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

HDDEDATA CALLBACK CallbackProc(UINT uType, UINT uFmt,HCONV hconv,HSZ hsz1,HSZ hsz2,
   HDDEDATA hdata,DWORD dwData1,DWORD dwData2)
{
    boolean bAllow;
    TPokeAction action;//bool PokeData(const System::AnsiString Item, char *Data);
    AnsiString sTopic;
    PDdeQueItem p ;
    char buf[256];

 // result := 0;
   switch (uType) {
        case XTYP_CONNECT: { return (HDDEDATA)1; }
        case XTYP_POKE:
       {
        {
          DdeQueryString(idInst,hsz1,buf,sizeof(buf),CP_WINANSI);
          sTopic=buf;
          action=paPass;//    
          Form1->Memo1->Lines->Add("XTYP_POKE");
          if (&Form1->OnDdePoke) (Form1->OnDdePoke(&sTopic,&action));
          //ShowMessage(action);
          switch (action){
          case paAccept: {
                        DdeQueryString(idInst,hsz2,buf,sizeof(buf),CP_WINANSI);
 /*************************/ //       New(p);
                        p->sTopic=sTopic;
                        p->sCells=buf;
                        p->size=DdeGetData(hdata,NULL,4,0);
//**************/   //           GetMem(p->data, p->size);   =   
                        DdeGetData(hdata,(unsigned char*)p->data,p->size,0);

                        try {
                          fDdeQue->LockList();
                          fDdeQue->Add(p);
                          Form1->Memo1->Lines->Add(p->sTopic+" "+p->sCells+" "+p->size);
                            }
                       __finally {
                        fDdeQue->UnlockList();
                                  }

                        if (Form1->Handle!=0) {
                        PostMessageA(Form1->Handle,WM_DDE_ADDQUE,0,0);
                        Form1->AddQ();
                        }
        //                    result := Dde_fAck;}

            case paPass: {return (HDDEDATA)dde_Ack;};
            case paReject: { return (HDDEDATA)dde_Busy; };
              };
         }
     }
 }

 void __fastcall TForm1::FormCreate(TObject *Sender)
{  Memo1->Lines->Add("in FormCreate");
   idInst=0;
   if (DdeInitializeA(&idInst,(PFNCALLBACK)CallbackProc,APPCLASS_STANDARD,0)==
       DMLERR_NO_ERROR) {
     ServiceHSz=DdeCreateStringHandleA(idInst,"rob",CP_WINANSI);
     TopicHSz=DdeCreateStringHandleA(idInst,"Topic",CP_WINANSI);
     if (DdeNameService(idInst,ServiceHSz,0,DNS_REGISTER)==0)
       ShowMessage("    DDE .");
   }
   else
     ShowMessage("    DDE.");

}

//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
   DdeNameService(idInst,ServiceHSz,0,DNS_UNREGISTER);
   fDdeQue->Free();
   DdeFreeStringHandle(idInst,ServiceHSz);
   DdeUninitialize(idInst);

}
//---------------------------------------------------------------------------

MESSAGE void __fastcall TForm1::AddQue(Messages::TWMSysCommand & Message)
{    Memo1->Lines->Add("in AddQue");
     TVariantTable vt;
     TRect Cells;
     int i;
     // /*???????????*/p: PDdeQueItem;
     try
     {

          p=(TDdeQueItem*)fDdeQue->LockList()->Items[fDdeQue->LockList()->Count-1];
          
          Cells=DecodeCellAddr(p->sCells);
          vt=XLTDecodeV(p->data,p->size);

          if (fOnData) { fOnData(p->sTopic,Cells, vt); }
          for (i=fDdeQue->LockList()->Count-1;i>0;i--)
          {
              p->data=fDdeQue->LockList()->Items[i];
              memset(p->data,0,p->size);
          }
      }
      __finally {  fDdeQue->UnlockList(); }
}
//---------------------------------------------------------------------------

TVariantTable __fastcall TForm1::XLTDecodeV(void * data, int datasize)
{   Memo1->Lines->Add("in XLTDecodeV");


  int i;
  Pointer curr;
  Word BlockType, BlockSize;
  Byte StringSize;
  float RealData;
  ShortString StringData;
  int DataNum=0;
  AnsiString s;


  curr = addp(data, 4);
  vtResult.RowCount=(int)curr;  //   
  curr=addp(curr, 2);
  vtResult.ColCount=(int)curr; //   
  
 /* ->*/ curr = addp(curr, 2);     //   
  Result.Cells.Length=vtResult.RowCount;


 for (i=0;vtResult.RowCount;i++){
    vtResult.Cells[i].Length=vtResult.ColCount; }


 /* */ DataNum = 0;

 while((int)subp(curr,data)<datasize)  //   
{  
  begin
    BlockType=(int)curr; /*  */
    curr=addp(curr, 2);
    BlockSize=(int)curr;  /*     */
    curr=addp(curr, 2);

    switch (BlockType){
      case 1: { //

          while(BlockSize>0) {
          RealData=(int)curr;
          curr=addp(curr,8);
          BlockSize-=8;//        dec(BlockSize, 8);
          vtResult.Cells[DataNum/vtResult.ColCount][DataNum%vtResult.ColCount]=RealData;
          DataNum++;
         }
       }

      case 2: { //
        while(BlockSize>0) {
          StringSize=(Byte)curr;
          curr=addp(curr);
          StringData[0]=(char)StringSize;
          for (i=1;i<StringSize;i++){
            StringData[i]=(char)curr;
            curr=addp(curr);
          }
          vtResult.Cells[DataNum/vtResult.ColCount][DataNum%vtResult.ColCount]=StringData;


          DataNum++;  //   inc(DataNum);
          BlockSize-=(StringSize+1); //  dec(BlockSize, StringSize+1);
           };
         }
    }
  }


  s.SetLength(datasize);
  for (i=0;i<(datasize-1);i++)  /*  -1    -*/
  {   
    s[i+1]=(char)addp(data,i);
  }
  return vtResult;
}
//---------------------------------------------------------------------------

Types::TRect __fastcall TForm1::DecodeCellAddr(AnsiString CellAddr)
{ 
  Memo1->Lines->Add("in DecodeCellAddr");
  /*   */  TRect rResult;
  int tmp1,tmp2;

   CellAddr=UpperCase(CellAddr);
  tmp1=PosEx("R", CellAddr, 1);
  tmp2=PosEx("C", CellAddr,tmp1);
  try {
      rResult.Top=StrToInt(CellAddr.SubString(tmp1+1,tmp2-tmp1-1))-1;
      }  //   -1,   Excel    1,    0
  catch(...)
  { exit; }

  
  tmp1=PosEx("R", CellAddr, tmp2);

  try
  {
     rResult.Left=StrToInt(CellAddr.SubString(tmp2+1,tmp1-tmp2-1-1))-1;  
   }    //  -1     ':' (R1C1:R5C12)
  catch(...)
  { exit; }

  tmp2 := PosEx('C', CellAddr, tmp1);

  try {
    rResult.Bottom=StrToInt(CellAddr.SubString(tmp1+1,tmp2-tmp1-1))-1;
    rResult.Right=StrToInt(CellAddr.SubString(tmp2+1,CellAddr.Length()-tmp2))-1;
  }
  catch(...)
  { exit; }
  return rResult;
}
//---------------------------------------------------------------------------

extern PACKAGE void * __fastcall addp(void * p, int increment = 0x1)/* overload */
  {  return (Pointer)((int)p+increment);}

extern PACKAGE void * __fastcall addp(void * p, void * increment)/* overload */
{  return (Pointer)((int)p+(int)increment);}

extern PACKAGE void * __fastcall subp(void * p, int decrement = 0x1)/* overload */
{ return (Pointer)((int)p-decrement); }

extern PACKAGE void * __fastcall subp(void * p, void * decrement)/* overload */
{ return (Pointer)((int)p-(int)decrement); }









